package com.aliyun.odps.spark.zhp

import com.alibaba.fastjson.{JSON, JSONObject, TypeReference}
import com.aliyun.odps.TableSchema
import com.aliyun.odps.data.Record
import examples.extractor.{ExtractorUtils, RankExtractorFeature_20240530}
import org.xm.Similarity

import scala.collection.JavaConversions._
import scala.collection.mutable.ArrayBuffer
import scala.io.Source

/*
   20240608 提取特征
 */

object makedata_ad_31_originData_20240628 {

  def main(args: Array[String]): Unit = {
    val metaFeatureJsonStr = "{\"alg_cid_feature_region_action\":{\"ad_click_3d\":\"9574\",\"ad_view_6h\":\"28523\",\"ad_click_1d\":\"4092\",\"ad_click_7d\":\"18708\",\"ad_click_14d\":\"18708\",\"ad_conversion_1d\":\"81\",\"ad_conversion_3h\":\"11\",\"ad_click_3h\":\"697\",\"ad_income_3d\":\"15678\",\"ad_conversion_14d\":\"374\",\"ad_income_3h\":\"858\",\"ad_income_1d\":\"6318\",\"ad_conversion_6h\":\"29\",\"ad_income_7d\":\"29172\",\"ad_click_12h\":\"2893\",\"ad_conversion_12h\":\"57\",\"ad_view_1d\":\"81288\",\"ad_click_6h\":\"1523\",\"ad_view_12h\":\"58493\",\"ad_view_3h\":\"13160\",\"ad_view_14d\":\"340375\",\"ad_conversion_7d\":\"374\",\"ad_income_14d\":\"29172\",\"ad_conversion_3d\":\"201\",\"ad_income_6h\":\"2262\",\"ad_view_7d\":\"340373\",\"ad_view_3d\":\"178981\",\"ad_income_12h\":\"4446\"},\"alg_cid_feature_week_action\":{\"ad_conversion_14d\":\"756\",\"ad_conversion_7d\":\"756\",\"ad_click_7d\":\"33786\",\"ad_click_14d\":\"33786\",\"ad_income_14d\":\"58968\",\"ad_view_7d\":\"668204\",\"ad_view_14d\":\"668213\",\"ad_income_7d\":\"58968\"},\"alg_cid_feature_vid_cf_rank\":{},\"alg_cid_feature_basic_info\":{},\"alg_cid_feature_brand_action\":{},\"alg_mid_feature_return_tags\":{\"tags_1d\":\"养好,儿子\",\"tags_14d\":\"养好,儿子\",\"tags_2h\":\"\",\"tags_7d\":\"养好,儿子\",\"tags_3d\":\"养好,儿子\"},\"alg_cid_feature_app_action\":{\"ad_click_3d\":\"966\",\"ad_view_6h\":\"2546\",\"ad_click_1d\":\"398\",\"ad_click_7d\":\"2948\",\"ad_click_14d\":\"2948\",\"ad_conversion_1d\":\"13\",\"ad_conversion_3h\":\"1\",\"ad_click_3h\":\"71\",\"ad_income_3d\":\"2262\",\"ad_conversion_14d\":\"75\",\"ad_income_3h\":\"78\",\"ad_income_1d\":\"1014\",\"ad_conversion_6h\":\"2\",\"ad_income_7d\":\"5850\",\"ad_click_12h\":\"276\",\"ad_conversion_12h\":\"7\",\"ad_view_1d\":\"7575\",\"ad_click_6h\":\"134\",\"ad_view_12h\":\"5274\",\"ad_view_3h\":\"1230\",\"ad_view_14d\":\"48868\",\"ad_conversion_7d\":\"75\",\"ad_income_14d\":\"5850\",\"ad_conversion_3d\":\"29\",\"ad_income_6h\":\"156\",\"ad_view_7d\":\"48868\",\"ad_view_3d\":\"17484\",\"ad_income_12h\":\"546\"},\"alg_cid_feature_adver_action\":{\"ad_click_3d\":\"177369\",\"ad_view_6h\":\"505824\",\"ad_click_1d\":\"78033\",\"ad_click_7d\":\"367268\",\"ad_click_14d\":\"367270\",\"ad_conversion_1d\":\"1798\",\"ad_conversion_3h\":\"326\",\"ad_click_3h\":\"12840\",\"ad_income_3d\":\"330576\",\"ad_conversion_14d\":\"8832\",\"ad_income_3h\":\"24546\",\"ad_income_1d\":\"134712\",\"ad_conversion_6h\":\"672\",\"ad_income_7d\":\"670400\",\"ad_click_12h\":\"53590\",\"ad_conversion_12h\":\"1200\",\"ad_view_1d\":\"1576476\",\"ad_click_6h\":\"26687\",\"ad_view_12h\":\"1085043\",\"ad_view_3h\":\"247915\",\"ad_view_14d\":\"6796514\",\"ad_conversion_7d\":\"8832\",\"ad_income_14d\":\"670400\",\"ad_conversion_3d\":\"4355\",\"ad_income_6h\":\"51084\",\"ad_view_7d\":\"6796468\",\"ad_view_3d\":\"3384791\",\"ad_income_12h\":\"90594\"},\"alg_cid_feature_cid_action\":{\"ad_click_3d\":\"90268\",\"ad_view_6h\":\"259476\",\"ad_click_1d\":\"37312\",\"ad_click_7d\":\"181617\",\"ad_click_14d\":\"181618\",\"ad_conversion_1d\":\"848\",\"ad_conversion_3h\":\"145\",\"ad_click_3h\":\"6366\",\"ad_income_3d\":\"169728\",\"ad_conversion_14d\":\"4302\",\"ad_income_3h\":\"11310\",\"ad_income_1d\":\"66144\",\"ad_conversion_6h\":\"331\",\"ad_income_7d\":\"335556\",\"ad_click_12h\":\"26442\",\"ad_conversion_12h\":\"569\",\"ad_view_1d\":\"750555\",\"ad_click_6h\":\"13804\",\"ad_view_12h\":\"532955\",\"ad_view_3h\":\"121622\",\"ad_view_14d\":\"3323960\",\"ad_conversion_7d\":\"4302\",\"ad_income_14d\":\"335556\",\"ad_conversion_3d\":\"2176\",\"ad_income_6h\":\"25818\",\"ad_view_7d\":\"3323946\",\"ad_view_3d\":\"1712853\",\"ad_income_12h\":\"44382\"},\"alg_mid_feature_share_tags\":{},\"alg_cid_feature_vid_cf\":{\"ad_click_3d\":\"283\",\"ad_view_6h\":\"575\",\"ad_click_1d\":\"99\",\"ad_click_7d\":\"333\",\"ad_click_14d\":\"333\",\"ad_conversion_1d\":\"2\",\"ad_conversion_3h\":\"0\",\"ad_click_3h\":\"11\",\"ad_income_3d\":\"624\",\"ad_conversion_14d\":\"10\",\"ad_income_3h\":\"0\",\"ad_income_1d\":\"156\",\"ad_conversion_6h\":\"1\",\"ad_income_7d\":\"780\",\"ad_click_12h\":\"45\",\"ad_conversion_12h\":\"1\",\"ad_view_1d\":\"2029\",\"ad_click_6h\":\"25\",\"ad_view_12h\":\"933\",\"ad_view_3h\":\"293\",\"ad_view_14d\":\"7964\",\"ad_conversion_7d\":\"10\",\"ad_income_14d\":\"780\",\"ad_conversion_3d\":\"8\",\"ad_income_6h\":\"78\",\"ad_view_7d\":\"7964\",\"ad_view_3d\":\"6663\",\"ad_income_12h\":\"78\"},\"alg_cid_feature_hour_action\":{},\"alg_mid_feature_ad_action\":{}}";
    val allFeatureJsonStr = "{\"b2_3h_ctcvr\":\"0.2558139534883721\",\"b5_12h_conver\":\"0.08433734939759037\",\"b6_14d_cvr\":\"0.18181818181818182\",\"b2_6h_ctcvr\":\"0.21739130434782608\",\"d1_feature_7d_ctr\":\"0.24\",\"b2_12h_conver\":\"0.9111111111111111\",\"b4_3h_ctr\":\"0.63\",\"b2_6h_cvr\":\"0.33333333333333337\",\"b3_6h_cvr\":\"0.22619047619047616\",\"b4_3h_ecpm\":\"0.24\",\"b3_7d_ecpm\":\"0.5232558139534884\",\"b2_3h_ctr\":\"0.5116279069767442\",\"b2_12h_cvr\":\"0.09090909090909091\",\"b5_3h_ctr\":\"0.8282828282828284\",\"b3_3h_ctr\":\"0.6385542168674699\",\"b3_1d_conver\":\"0.9\",\"b5_7d_cvr\":\"0.29\",\"b4_7d_cvr\":\"0.12\",\"b6_7d_cvr\":\"0.18181818181818182\",\"b4_1d_conver\":\"0.9122807017543859\",\"b2_7d_cvr\":\"0.1\",\"b5_3d_ecpm\":\"0.8989898989898991\",\"b3_7d_cvr\":\"0.16470588235294117\",\"b4_6h_ecpm\":\"0.33\",\"d1_feature_6h_cvr\":\"0.53125\",\"b2_3d_ecpm\":\"0.14583333333333331\",\"b3_3h_ctcvr\":\"0.21686746987951808\",\"b6_7d_conver\":\"0.9411764705882353\",\"b4_6h_cvr\":\"0.21\",\"b3_1d_ecpm\":\"0.3103448275862069\",\"d1_feature_12h_ecpm\":\"0.3\",\"b5_12h_ctr\":\"0.6363636363636365\",\"d1_feature_1d_cvr\":\"0.18\",\"d1_feature_3d_conver\":\"0.16\",\"b6_7d_ecpm\":\"0.2631578947368421\",\"b4_1d_ctcvr\":\"0.19\",\"d1_feature_7d_cvr\":\"0.44\",\"b2_12h_ctcvr\":\"0.044444444444444446\",\"b4_6h_ctr\":\"0.64\",\"b3_6h_conver\":\"0.8840579710144928\",\"b5_6h_ctr\":\"0.6464646464646465\",\"b2_3h_cvr\":\"0.35555555555555557\",\"b2_12h_ctr\":\"0.29166666666666663\",\"b2_7d_ecpm\":\"0.16326530612244897\",\"b4_12h_ecpm\":\"0.28\",\"b3_6h_ctcvr\":\"0.21686746987951808\",\"b5_3h_cvr\":\"0.07\",\"b6_14d_conver\":\"0.9411764705882353\",\"b3_3d_ctr\":\"0.6292134831460674\",\"b5_7d_ctr\":\"0.888888888888889\",\"d1_feature_6h_ctcvr\":\"0.43\",\"b4_3d_ctr\":\"0.6900000000000001\",\"b4_7d_ctr\":\"0.74\",\"d1_feature_12h_ctcvr\":\"0.18\",\"b5_6h_ecpm\":\"0.13265306122448978\",\"b3_3h_ecpm\":\"0.41250000000000003\",\"b4_3h_conver\":\"0.5238095238095237\",\"b4_3d_ecpm\":\"0.32\",\"b2_6h_ecpm\":\"0.4545454545454546\",\"d1_feature_3d_ctcvr\":\"0.3\",\"b4_7d_conver\":\"0.9489795918367346\",\"b4_3d_cvr\":\"0.13\",\"b2_1d_cvr\":\"0.1\",\"b5_1d_ctr\":\"0.6464646464646465\",\"d1_feature_7d_ctcvr\":\"0.37\",\"b2_1d_ecpm\":\"0.10416666666666666\",\"b5_6h_cvr\":\"0.07142857142857142\",\"b5_7d_ctcvr\":\"0.54\",\"b2_1d_conver\":\"1.0\",\"b5_1d_conver\":\"0.14130434782608695\",\"b5_12h_cvr\":\"0.29\",\"b5_3d_ctcvr\":\"0.62\",\"b2_12h_ecpm\":\"0.0851063829787234\",\"d1_feature_7d_conver\":\"0.1724137931034483\",\"b3_3h_conver\":\"0.782608695652174\",\"b3_12h_ctr\":\"0.5172413793103449\",\"b5_12h_ecpm\":\"0.595959595959596\",\"b4_12h_cvr\":\"0.2\",\"d1_feature_12h_cvr\":\"0.17346938775510204\",\"b3_7d_conver\":\"0.9302325581395349\",\"b4_12h_ctcvr\":\"0.2\",\"b2_3d_cvr\":\"0.1\",\"b5_1d_cvr\":\"0.595959595959596\",\"b5_6h_conver\":\"0.030303030303030304\",\"b2_3h_ecpm\":\"0.48888888888888893\",\"b5_6h_ctcvr\":\"0.07070707070707072\",\"b6_14d_ecpm\":\"0.2631578947368421\",\"b4_3d_conver\":\"0.946236559139785\",\"b5_3h_ctcvr\":\"0.08080808080808081\",\"d1_feature_1d_ctr\":\"0.49\",\"b2_7d_conver\":\"0.9318181818181819\",\"b3_7d_ctcvr\":\"0.18181818181818182\",\"b5_1d_ecpm\":\"0.9191919191919192\",\"d1_feature_3d_ecpm\":\"0.45\",\"b3_12h_conver\":\"0.9240506329113924\",\"b3_1d_cvr\":\"0.15730337078651685\",\"b5_3d_cvr\":\"0.55\",\"b4_1d_ctr\":\"0.54\",\"b2_1d_ctcvr\":\"0.061224489795918366\",\"b2_1d_ctr\":\"0.36\",\"b3_3d_cvr\":\"0.1590909090909091\",\"b3_3d_ctcvr\":\"0.1744186046511628\",\"b4_6h_conver\":\"0.8666666666666667\",\"cid_1449\":\"1.0\",\"b3_1d_ctcvr\":\"0.1590909090909091\",\"b4_12h_conver\":\"0.926829268292683\",\"b2_7d_ctcvr\":\"0.08163265306122448\",\"d1_feature_6h_conver\":\"0.045454545454545456\",\"b2_3d_ctcvr\":\"0.08163265306122448\",\"b4_3h_ctcvr\":\"0.16\",\"d1_feature_3d_ctr\":\"0.27\",\"b5_12h_ctcvr\":\"0.26\",\"b3_3d_conver\":\"0.8214285714285714\",\"b5_7d_ecpm\":\"0.86\",\"b4_3d_ctcvr\":\"0.2\",\"b4_12h_ctr\":\"0.45\",\"b3_12h_cvr\":\"0.1511627906976744\",\"b5_3d_conver\":\"0.16129032258064518\",\"b3_6h_ctr\":\"0.6235294117647059\",\"b3_3h_cvr\":\"0.24705882352941178\",\"b2_6h_ctr\":\"0.4782608695652174\",\"d1_feature_12h_ctr\":\"0.45\",\"b4_3h_cvr\":\"0.15\",\"b6_14d_ctcvr\":\"0.07692307692307693\",\"b5_3h_ecpm\":\"0.14141414141414144\",\"b6_14d_ctr\":\"0.6153846153846154\",\"b2_3d_ctr\":\"0.44\",\"b6_7d_ctr\":\"0.6153846153846154\",\"d1_feature_1d_ecpm\":\"0.32\",\"b5_7d_conver\":\"0.2040816326530612\",\"d1_feature_7d_ecpm\":\"0.49\",\"b2_3d_conver\":\"0.8043478260869565\",\"b2_6h_conver\":\"1.0\",\"b3_7d_ctr\":\"0.6477272727272727\",\"b4_7d_ctcvr\":\"0.16\",\"b2_7d_ctr\":\"0.78\",\"b3_6h_ecpm\":\"0.5357142857142857\",\"d1_feature_1d_conver\":\"0.06060606060606061\",\"d1_feature_12h_conver\":\"0.037037037037037035\",\"b3_3d_ecpm\":\"0.4\",\"d1_feature_6h_ctr\":\"0.34\",\"d1_feature_3h_ctr\":\"0.2\",\"d1_feature_6h_ecpm\":\"0.53\",\"b6_7d_ctcvr\":\"0.07692307692307693\",\"b2_3h_conver\":\"0.8604651162790697\",\"b4_6h_ctcvr\":\"0.22\",\"b3_12h_ecpm\":\"0.20689655172413793\",\"b4_1d_ecpm\":\"0.27\",\"b3_1d_ctr\":\"0.5795454545454546\",\"b5_3d_ctr\":\"0.8300000000000001\",\"b4_1d_cvr\":\"0.18\",\"d1_feature_1d_ctcvr\":\"0.2\",\"d1_feature_3d_cvr\":\"0.34\",\"b5_3h_conver\":\"0.016129032258064516\",\"b4_7d_ecpm\":\"0.32\",\"b5_1d_ctcvr\":\"0.787878787878788\",\"b3_12h_ctcvr\":\"0.15476190476190477\"}";

    val allFeatureJson = JSON.parseObject(allFeatureJsonStr);

    val metaFeatureJson = keyReplace(metaFeatureJsonStr)
    metaFeatureJson.put("cid", 2755);
    metaFeatureJson.put("ts", 1719802244);

    List((metaFeatureJson, allFeatureJson))
      .foreach((jsonItem => {

        val record = jsonItem._1

        val ts = record.getString("ts").toInt
        val cid = record.getString("cid")

        val featureMap = new JSONObject()

        val b1: JSONObject = if (!record.contains("b1_feature")) new JSONObject() else
          JSON.parseObject(record.getString("b1_feature"))
        val b2: JSONObject = if (!record.contains("b2_feature")) new JSONObject() else
          JSON.parseObject(record.getString("b2_feature"))
        val b3: JSONObject = if (!record.contains("b3_feature")) new JSONObject() else
          JSON.parseObject(record.getString("b3_feature"))
        val b4: JSONObject = if (!record.contains("b4_feature")) new JSONObject() else
          JSON.parseObject(record.getString("b4_feature"))
        val b5: JSONObject = if (!record.contains("b5_feature")) new JSONObject() else
          JSON.parseObject(record.getString("b5_feature"))
        val b6: JSONObject = if (!record.contains("b6_feature")) new JSONObject() else
          JSON.parseObject(record.getString("b6_feature"))
        val b7: JSONObject = if (!record.contains("b7_feature")) new JSONObject() else
          JSON.parseObject(record.getString("b7_feature"))
        val b8: JSONObject = if (!record.contains("b8_feature")) new JSONObject() else
          JSON.parseObject(record.getString("b8_feature"))
        val b9: JSONObject = if (!record.contains("b9_feature")) new JSONObject() else
          JSON.parseObject(record.getString("b9_feature"))


        featureMap.put("cid_" + cid, 1.0)
        if (b1.containsKey("adid") && b1.getString("adid").nonEmpty) {
          featureMap.put("adid_" + b1.getString("adid"), 1.0)
        }
        if (b1.containsKey("adverid") && b1.getString("adverid").nonEmpty) {
          featureMap.put("adverid_" + b1.getString("adverid"), 1.0)
        }
        if (b1.containsKey("targeting_conversion") && b1.getString("targeting_conversion").nonEmpty) {
          featureMap.put("targeting_conversion_" + b1.getString("targeting_conversion"), 1.0)
        }


        if (b1.containsKey("cpa")) {
          featureMap.put("cpa", b1.getString("cpa").toDouble)
        }

        for ((bn, prefix1) <- List(
          (b2, "b2"), (b3, "b3"), (b4, "b4"), (b5, "b5"), (b8, "b8")
        )) {
          for (prefix2 <- List(
            "3h", "6h", "12h", "1d", "3d", "7d"
          )) {
            val view = if (bn.isEmpty) 0D else bn.getIntValue("ad_view_" + prefix2).toDouble
            val click = if (bn.isEmpty) 0D else bn.getIntValue("ad_click_" + prefix2).toDouble
            val conver = if (bn.isEmpty) 0D else bn.getIntValue("ad_conversion_" + prefix2).toDouble
            val income = if (bn.isEmpty) 0D else bn.getIntValue("ad_income_" + prefix2).toDouble
            val f1 = RankExtractorFeature_20240530.calDiv(click, view)
            val f2 = RankExtractorFeature_20240530.calDiv(conver, view)
            val f3 = RankExtractorFeature_20240530.calDiv(conver, click)
            val f4 = conver
            val f5 = RankExtractorFeature_20240530.calDiv(income * 1000, view)
            featureMap.put(prefix1 + "_" + prefix2 + "_" + "ctr", f1)
            featureMap.put(prefix1 + "_" + prefix2 + "_" + "ctcvr", f2)
            featureMap.put(prefix1 + "_" + prefix2 + "_" + "cvr", f3)
            featureMap.put(prefix1 + "_" + prefix2 + "_" + "conver", f4)
            featureMap.put(prefix1 + "_" + prefix2 + "_" + "ecpm", f5)
          }
        }

        for ((bn, prefix1) <- List(
          (b6, "b6"), (b7, "b7")
        )) {
          for (prefix2 <- List(
            "7d", "14d"
          )) {
            val view = if (bn.isEmpty) 0D else bn.getIntValue("ad_view_" + prefix2).toDouble
            val click = if (bn.isEmpty) 0D else bn.getIntValue("ad_click_" + prefix2).toDouble
            val conver = if (bn.isEmpty) 0D else bn.getIntValue("ad_conversion_" + prefix2).toDouble
            val income = if (bn.isEmpty) 0D else bn.getIntValue("ad_income_" + prefix2).toDouble
            val f1 = RankExtractorFeature_20240530.calDiv(click, view)
            val f2 = RankExtractorFeature_20240530.calDiv(conver, view)
            val f3 = RankExtractorFeature_20240530.calDiv(conver, click)
            val f4 = conver
            val f5 = RankExtractorFeature_20240530.calDiv(income * 1000, view)
            featureMap.put(prefix1 + "_" + prefix2 + "_" + "ctr", f1)
            featureMap.put(prefix1 + "_" + prefix2 + "_" + "ctcvr", f2)
            featureMap.put(prefix1 + "_" + prefix2 + "_" + "cvr", f3)
            featureMap.put(prefix1 + "_" + prefix2 + "_" + "conver", f4)
            featureMap.put(prefix1 + "_" + prefix2 + "_" + "ecpm", f5)
          }
        }

        val c1: JSONObject = if (!record.contains("c1_feature")) new JSONObject() else
          JSON.parseObject(record.getString("c1_feature"))

        val midActionList = if (c1.containsKey("action") && c1.getString("action").nonEmpty) {
          c1.getString("action").split(",").map(r => {
            val rList = r.split(":")
            (rList(0), (rList(1).toInt, rList(2).toInt, rList(3).toInt, rList(4).toInt, rList(5)))
          }).sortBy(-_._2._1).toList
        } else {
          new ArrayBuffer[(String, (Int, Int, Int, Int, String))]().toList
        }
        // u特征
        val viewAll = midActionList.size.toDouble
        val clickAll = midActionList.map(_._2._2).sum.toDouble
        val converAll = midActionList.map(_._2._3).sum.toDouble
        val incomeAll = midActionList.map(_._2._4).sum.toDouble
        featureMap.put("viewAll", viewAll)
        featureMap.put("clickAll", clickAll)
        featureMap.put("converAll", converAll)
        featureMap.put("incomeAll", incomeAll)
        featureMap.put("ctr_all", RankExtractorFeature_20240530.calDiv(clickAll, viewAll))
        featureMap.put("ctcvr_all", RankExtractorFeature_20240530.calDiv(converAll, viewAll))
        featureMap.put("cvr_all", RankExtractorFeature_20240530.calDiv(clickAll, converAll))
        featureMap.put("ecpm_all", RankExtractorFeature_20240530.calDiv(incomeAll * 1000, viewAll))

        // ui特征
        val midTimeDiff = scala.collection.mutable.Map[String, Double]()
        midActionList.foreach {
          case (cid, (ts_history, click, conver, income, title)) =>
            if (!midTimeDiff.contains("timediff_view_" + cid)) {
              midTimeDiff.put("timediff_view_" + cid, 1.0 / ((ts - ts_history).toDouble / 3600.0 / 24.0))
            }
            if (!midTimeDiff.contains("timediff_click_" + cid) && click > 0) {
              midTimeDiff.put("timediff_click_" + cid, 1.0 / ((ts - ts_history).toDouble / 3600.0 / 24.0))
            }
            if (!midTimeDiff.contains("timediff_conver_" + cid) && conver > 0) {
              midTimeDiff.put("timediff_conver_" + cid, 1.0 / ((ts - ts_history).toDouble / 3600.0 / 24.0))
            }
        }

        val midActionStatic = scala.collection.mutable.Map[String, Double]()
        midActionList.foreach {
          case (cid, (ts_history, click, conver, income, title)) =>
            midActionStatic.put("actionstatic_view_" + cid, 1.0 + midActionStatic.getOrDefault("actionstatic_view_" + cid, 0.0))
            midActionStatic.put("actionstatic_click_" + cid, click + midActionStatic.getOrDefault("actionstatic_click_" + cid, 0.0))
            midActionStatic.put("actionstatic_conver_" + cid, conver + midActionStatic.getOrDefault("actionstatic_conver_" + cid, 0.0))
            midActionStatic.put("actionstatic_income_" + cid, income + midActionStatic.getOrDefault("actionstatic_income_" + cid, 0.0))
        }

        if (midTimeDiff.contains("timediff_view_" + cid)) {
          featureMap.put("timediff_view", midTimeDiff.getOrDefault("timediff_view_" + cid, 0.0))
        }
        if (midTimeDiff.contains("timediff_click_" + cid)) {
          featureMap.put("timediff_click", midTimeDiff.getOrDefault("timediff_click_" + cid, 0.0))
        }
        if (midTimeDiff.contains("timediff_conver_" + cid)) {
          featureMap.put("timediff_conver", midTimeDiff.getOrDefault("timediff_conver_" + cid, 0.0))
        }
        if (midActionStatic.contains("actionstatic_view_" + cid)) {
          featureMap.put("actionstatic_view", midActionStatic.getOrDefault("actionstatic_view_" + cid, 0.0))
        }
        if (midActionStatic.contains("actionstatic_click_" + cid)) {
          featureMap.put("actionstatic_click", midActionStatic.getOrDefault("actionstatic_click_" + cid, 0.0))
        }
        if (midActionStatic.contains("actionstatic_conver_" + cid)) {
          featureMap.put("actionstatic_conver", midActionStatic.getOrDefault("actionstatic_conver_" + cid, 0.0))
        }
        if (midActionStatic.contains("actionstatic_income_" + cid)) {
          featureMap.put("actionstatic_income", midActionStatic.getOrDefault("actionstatic_income_" + cid, 0.0))
        }
        if (midActionStatic.contains("actionstatic_view_" + cid) && midActionStatic.contains("actionstatic_click_" + cid)) {
          featureMap.put("actionstatic_ctr", RankExtractorFeature_20240530.calDiv(
            midActionStatic.getOrDefault("actionstatic_click_" + cid, 0.0),
            midActionStatic.getOrDefault("actionstatic_view_" + cid, 0.0)
          ))
        }
        if (midActionStatic.contains("actionstatic_view_" + cid) && midActionStatic.contains("timediff_conver_" + cid)) {
          featureMap.put("actionstatic_ctcvr", RankExtractorFeature_20240530.calDiv(
            midActionStatic.getOrDefault("timediff_conver_" + cid, 0.0),
            midActionStatic.getOrDefault("actionstatic_view_" + cid, 0.0)
          ))
        }
        if (midActionStatic.contains("actionstatic_conver_" + cid) && midActionStatic.contains("actionstatic_click_" + cid)) {
          featureMap.put("actionstatic_cvr", RankExtractorFeature_20240530.calDiv(
            midActionStatic.getOrDefault("actionstatic_click_" + cid, 0.0),
            midActionStatic.getOrDefault("timediff_conver_" + cid, 0.0)
          ))
        }

        val e1: JSONObject = if (!record.contains("e1_feature")) new JSONObject() else
          JSON.parseObject(record.getString("e1_feature"))
        val e2: JSONObject = if (!record.contains("e2_feature")) new JSONObject() else
          JSON.parseObject(record.getString("e2_feature"))
        val title = b1.getOrDefault("cidtitle", "").toString
        if (title.nonEmpty) {
          for ((en, prefix1) <- List((e1, "e1"), (e2, "e2"))) {
            for (prefix2 <- List("tags_3d", "tags_7d", "tags_14d")) {
              if (en.nonEmpty && en.containsKey(prefix2) && en.getString(prefix2).nonEmpty) {
                val (f1, f2, f3, f4) = funcC34567ForTags(en.getString(prefix2), title)
                featureMap.put(prefix1 + "_" + prefix2 + "_matchnum", f1)
                featureMap.put(prefix1 + "_" + prefix2 + "_maxscore", f3)
                featureMap.put(prefix1 + "_" + prefix2 + "_avgscore", f4)

              }
            }
          }
        }

        val d1: JSONObject = if (!record.contains("d1_feature")) new JSONObject() else
          JSON.parseObject(record.getString("d1_feature"))
        val d2: JSONObject = if (!record.contains("d2_feature")) new JSONObject() else
          JSON.parseObject(record.getString("d2_feature"))

        if (d1.nonEmpty) {
          for (prefix <- List("3h", "6h", "12h", "1d", "3d", "7d")) {
            val view = if (!d1.containsKey("ad_view_" + prefix)) 0D else d1.getIntValue("ad_view_" + prefix).toDouble
            val click = if (!d1.containsKey("ad_click_" + prefix)) 0D else d1.getIntValue("ad_click_" + prefix).toDouble
            val conver = if (!d1.containsKey("ad_conversion_" + prefix)) 0D else d1.getIntValue("ad_conversion_" + prefix).toDouble
            val income = if (!d1.containsKey("ad_income_" + prefix)) 0D else d1.getIntValue("ad_income_" + prefix).toDouble
            val f1 = RankExtractorFeature_20240530.calDiv(click, view)
            val f2 = RankExtractorFeature_20240530.calDiv(conver, view)
            val f3 = RankExtractorFeature_20240530.calDiv(conver, click)
            val f4 = conver
            val f5 = RankExtractorFeature_20240530.calDiv(income * 1000, view)
            featureMap.put("d1_feature" + "_" + prefix + "_" + "ctr", f1)
            featureMap.put("d1_feature" + "_" + prefix + "_" + "ctcvr", f2)
            featureMap.put("d1_feature" + "_" + prefix + "_" + "cvr", f3)
            featureMap.put("d1_feature" + "_" + prefix + "_" + "conver", f4)
            featureMap.put("d1_feature" + "_" + prefix + "_" + "ecpm", f5)
          }
        }

        val vidRankMaps = scala.collection.mutable.Map[String, scala.collection.immutable.Map[String, Double]]()
        if (d2.nonEmpty) {
          d2.foreach(r => {
            val key = r._1
            val value = d2.getString(key).split(",").map(r => {
              val rList = r.split(":")
              (rList(0), rList(2).toDouble)
            }).toMap
            vidRankMaps.put(key, value)
          })
        }
        for (prefix1 <- List("ctr", "ctcvr", "ecpm")) {
          for (prefix2 <- List("1d", "3d", "7d", "14d")) {
            if (vidRankMaps.contains(prefix1 + "_" + prefix2)) {
              val rank = vidRankMaps(prefix1 + "_" + prefix2).getOrDefault(cid, 0.0)
              if (rank >= 1.0) {
                featureMap.put("vid_rank_" + prefix1 + "_" + prefix2, 1.0 / rank)
              }
            }
          }
        }


        /*
        广告
          sparse：cid adid adverid targeting_conversion

          cpa --> 1个
          adverid下的 3h 6h 12h 1d 3d 7d 、 ctr ctcvr cvr conver ecpm  --> 30个
          cid下的 3h 6h 12h 1d 3d 7d 、 ctr ctcvr cvr ecpm conver --> 30个
          地理//cid下的 3h 6h 12h 1d 3d 7d 、 ctr ctcvr cvr ecpm conver --> 30个
          app//cid下的 3h 6h 12h 1d 3d 7d 、 ctr ctcvr cvr ecpm conver --> 30个
          手机品牌//cid下的 3h 6h 12h 1d 3d 7d 、 ctr ctcvr cvr ecpm conver --> 30个
          系统 无数据
          week//cid下的 7d 14d、 ctr ctcvr cvr ecpm conver --> 10个
          hour//cid下的 7d 14d、 ctr ctcvr cvr ecpm conver --> 10个

        用户
          用户历史 点击/转化 的title tag；3d 7d 14d； cid的title； 数量/最高分/平均分 --> 18个
          用户历史 14d 看过/点过/转化次数/income； ctr cvr ctcvr ecpm；  --> 8个

          用户到cid的ui特征 --> 10个
            1/用户最近看过这个cid的时间间隔
            1/用户最近点过这个cid的时间间隔
            1/用户最近转过这个cid的时间间隔
            用户看过这个cid多少次
            用户点过这个cid多少次
            用户转过这个cid多少次
            用户对这个cid花了多少钱
            用户对这个cid的ctr ctcvr cvr

        视频
          title与cid的 sim-score-1/-2 无数据
          vid//cid下的 3h 6h 12h 1d 3d 7d 、 ctr ctcvr cvr ecpm conver --> 30个
          vid//cid下的 1d 3d 7d 14d、 ctr ctcvr ecpm 的rank值 倒数 --> 12个

         */


        val allFeatureJson = jsonItem._2

        val newFeatureMap = featureBucket(featureMap);

        for (entry <- newFeatureMap.entrySet()) {
          val key = entry.getKey
          val value = entry.getValue
          if (allFeatureJson.contains(key)) {
            if (!value.toString.equals(allFeatureJson.get(key).toString)) {
              println("特征Key: ", key, "异常，值不相等: [", value, "] != [", allFeatureJson.get(key), "]")
            }
          } else {
            println("特征Key: ", key, "异常，不存在")
          }
        }


        for (entry <- allFeatureJson.entrySet()) {
          var key = entry.getKey
          var value = entry.getValue
          if (newFeatureMap.contains(key)) {
            if (!value.toString.equals(newFeatureMap.get(key).toString)) {
              println("特征Key: ", key, "异常，值不相等: [", value, "] != [", newFeatureMap.get(key), "]")
            }
          } else {
            println("特征Key: ", key, "异常，多余")
          }
        }

      }))
  }

  def func(record: Record, schema: TableSchema): Record = {
    record
  }

  def funcC34567ForTags(tags: String, title: String): Tuple4[Double, String, Double, Double] = {
    // 匹配数量 匹配词 语义最高相似度分 语义平均相似度分
    val tagsList = tags.split(",")
    var d1 = 0.0
    val d2 = new ArrayBuffer[String]()
    var d3 = 0.0
    var d4 = 0.0
    for (tag <- tagsList) {
      if (title.contains(tag)) {
        d1 = d1 + 1.0
        d2.add(tag)
      }
      val score = Similarity.conceptSimilarity(tag, title)
      d3 = if (score > d3) score else d3
      d4 = d4 + score
    }
    d4 = if (tagsList.nonEmpty) d4 / tagsList.size else d4
    (d1, d2.mkString(","), d3, d4)
  }

  def keyReplace(record: String): JSONObject = {
    var json = JSON.parseObject(record);
    var newJson = new JSONObject();
    var tableNameToKey = List(
      ("alg_cid_feature_basic_info", "b1"),
      ("alg_cid_feature_adver_action", "b2"),
      ("alg_cid_feature_cid_action", "b3"),
      ("alg_cid_feature_region_action", "b4"),
      ("alg_cid_feature_app_action", "b5"),
      ("alg_cid_feature_week_action", "b6"),
      ("alg_cid_feature_hour_action", "b7"),
      ("alg_cid_feature_brand_action", "b8"),
      ("alg_cid_feature_weChatVersion_action", "b9"),
      ("alg_mid_feature_ad_action", "c1"),
      ("alg_cid_feature_vid_cf", "d1"),
      ("alg_cid_feature_vid_cf_rank", "d2"),
      ("alg_vid_feature_basic_info", "d3"),
      ("alg_mid_feature_return_tags", "e1"),
      ("alg_mid_feature_share_tags", "e2")
    );

    for ((table, key) <- tableNameToKey) {
      if (json.contains(table)) {
        newJson.put(key + "_feature", json.getString(table));
      }
    }

    newJson;
  }

  def featureBucket(featureJson: JSONObject): JSONObject = {
    val newJson = new JSONObject()

    val resourceUrlBucket = getClass.getClassLoader.getResource("20240622_ad_bucket_249.txt")
    var buckets = "";
    if (resourceUrlBucket != null) {
      buckets = Source.fromURL(resourceUrlBucket).getLines().mkString("\n")
      Source.fromURL(resourceUrlBucket).close()
    }


    val bucketsMap = buckets.split("\n")
      .map(r => r.replace(" ", "").replaceAll("\n", ""))
      .filter(r => r.nonEmpty)
      .map(r => {
        val rList = r.split("\t")
        (rList(0), (rList(1).toDouble, rList(2).split(",").map(_.toDouble)))
      }).toMap

    for ((key, value) <- featureJson) {
      if (value.toString.toDouble > 1E-18) {
        if (bucketsMap.contains(key)) {
          val (_, buckets) = bucketsMap(key)
          val scoreNew = 1.0 / (buckets.length + 1) * (ExtractorUtils.findInsertPosition(buckets, value.toString.toDouble).toDouble + 1.0)
          newJson.put(key, scoreNew);
        } else {
          newJson.put(key, value);
        }
      }
    }

    newJson;
  }

}
